// LICENSE : MIT
"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _matchProps = require("./utils/match-props");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require("react");

var ToggleOrPattern = function (_React$Component) {
    _inherits(ToggleOrPattern, _React$Component);

    function ToggleOrPattern() {
        _classCallCheck(this, ToggleOrPattern);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(ToggleOrPattern).apply(this, arguments));
    }

    _createClass(ToggleOrPattern, [{
        key: "getFlagNames",
        value: function getFlagNames() {
            return Object.keys(this.props).filter(function (key) {
                return key !== "children";
            });
        }

        /**
         * get components from `children` that matches key and value with own props.
         * @returns {ReactComponent[]}
         */

    }, {
        key: "getMatchedComponent",
        value: function getMatchedComponent() {
            var _this2 = this;

            var children = [].concat(this.props.children);
            var flagKeyNames = this.getFlagNames();
            return children.filter(function (child) {
                // ignore text child
                if (!child.props) {
                    return false;
                }
                // all match
                return (0, _matchProps.matchOr)(flagKeyNames, _this2.props, child.props);
            });
        }
    }, {
        key: "render",
        value: function render() {
            var components = this.getMatchedComponent();
            if (components.length === 0) {
                return null;
            }
            if (components.length === 1) {
                return components[0];
            }
            return React.createElement(
                "div",
                { className: "TogglePattern ToggleOrPattern" },
                components
            );
        }
    }]);

    return ToggleOrPattern;
}(React.Component);

exports.default = ToggleOrPattern;
//# sourceMappingURL=ToggleOrPattern.js.map