// LICENSE : MIT
"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var React = require("react");

var TogglePattern = exports.TogglePattern = function (_React$Component) {
    _inherits(TogglePattern, _React$Component);

    function TogglePattern() {
        _classCallCheck(this, TogglePattern);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(TogglePattern).apply(this, arguments));
    }

    _createClass(TogglePattern, [{
        key: "getFlagNames",
        value: function getFlagNames() {
            return Object.keys(this.props);
        }

        /**
         * get components from `children` that matches key and value with own props.
         * @returns {ReactComponent[]}
         */

    }, {
        key: "getMatchedComponent",
        value: function getMatchedComponent() {
            var _this2 = this;

            var children = [].concat(this.props.children);
            var flagKeyNames = this.getFlagNames();
            return children.filter(function (child) {
                // ignore text child
                if (!child.props) {
                    return false;
                }
                var childKeys = Object.keys(child.props);
                return childKeys.some(function (childKey) {
                    return flagKeyNames.some(function (parentKey) {
                        var parentValue = _this2.props[parentKey];
                        var childValue = child.props[childKey];
                        return childValue === parentValue;
                    });
                });
            });
        }
    }, {
        key: "render",
        value: function render() {
            var components = this.getMatchedComponent();
            if (components.length === 0) {
                return null;
            }
            if (components.length === 1) {
                return components[0];
            }
            return React.createElement(
                "div",
                { className: "TogglePattern" },
                components
            );
        }
    }]);

    return TogglePattern;
}(React.Component);
//# sourceMappingURL=react-toggle-pattern.js.map